// Accessing interfaces within .DLL files without using COM example
// Written by Justin Blackwell
// email: jdb8@ukc.ac.uk

#include <windows.h>
#include "..\include\IRenderer.h"

int main( )
{
	CREATERENDERERINSTANCE pfnCreate;
	FREERENDERERINSTANCE pfnFree;
	IRenderer *theRenderer;

	// Try to load the dll
	HINSTANCE theDLL = LoadLibrary( "..\\D3DRenderer\\Debug\\D3DRenderer.dll" );

	if ( theDLL == NULL )
	{
		MessageBox( NULL, "Could not load the DLL", "Oooops...", MB_ICONERROR | MB_OK );
		return 0;
	}

	
	// Once loaded, get the create function
	pfnCreate = ( CREATERENDERERINSTANCE ) GetProcAddress( theDLL, "CreateRendererInstance" );

	// Then use it to create our renderer
	theRenderer = ( IRenderer *) pfnCreate();

	// Call the function
	theRenderer->Render3DGame();

	// Now get the free function from the dll
	pfnFree = ( FREERENDERERINSTANCE ) GetProcAddress( theDLL, "FreeRendererInstance" );

	// free the renderer
	pfnFree( theRenderer );

	// free the DLL
	FreeLibrary( theDLL );

	return 0;

}
